【leetcode 力扣刷题】双指针///原地扩充线性表

双指针///原地扩充线性表

剑指 Offer 05. 替换空格

题目链接:剑指 Offer 05. 替换空格

题目内容:

这是一道简单题,理解题意,就是将字符串s中的空格' '替换成'%20'。需要注意:一个空格是一个char,替换成'%20'是3个char。

这里有两种思路:一种是定义一个新的string变量ss,ss是s替换空格后的版本;一种是先扩充s的长度,然后在s上替换空格。

定义一个新字符串

这个方法先定义一个新的字符串ss,需要申请额外的空间。从前往后遍历s的时候,如果si != ' ',ssj = si,直接复制s的元素;如果si == ' ',那么ssj/ssj+1/ssj+2分别赋值'%','2','0',直到遍历完s。

【注意】需要先遍历s,统计s中空格的数量,以确定ss的长度为s.size() + 2 * count 。

代码如下(C++):

cpp 复制代码
lass Solution {
public:
    string replaceSpace(string s) {
    	//先统计s中的空格数量
        int count = 0;
        for(int i = 0; i < s.size(); i++){
            if(s[i] == ' ')
                count++;
        }
        //申请新的空间s.size()+2*count
        string ss(s.size()+2*count,' ');
        for(int i = 0, j = 0; i < s.size(); i++){
            if(s[i] == ' '){ //替换空格
                ss[j++] = '%';
                ss[j++] = '2';
                ss[j++] = '0';
            }
            else{
                ss[j++] = s[i];
            }
        }
        return ss;
    }
};

扩充字符串,原地替换

上面的方法很容易想到,但是需要额外申请s.size()+2*count的空间。是否有空间复杂度更低的方法呢?

如果将空格替换成其他字符比如'a',那么可以直接从前往后【从后往前也是可以的】遍历字符串中的每个字符,如果si==' ',就si = 'a'。这道题可以这么做吗? 答案是不行的。如果是si == ' '后,si和si+1和si+2分别赋值'%','2','0',那么本身的si+1/si+2的值就会被覆盖 。

但是从后往前遍历就可以!先把s长度扩充为替换后的长度s.size() + 2 * count。双指针一个front定位在s原长度 的最后一个元素;behind定位在s新长度 的最后一个元素。front逐步前移,遍历s中的字符;如果sfront != ' '→sbehind = sfront;如果sfront == ' '→sbehind-2/sbehind-1/sbehind分别赋值'%''2''0'。

从后往前遍历,不存在上面提到的s中一些未被遍历的元素被覆盖的情况。 因为front始终是小于等于behind 的,而只有behind小于了front才有未遍历元素被覆盖。小于说明front指针前还有空格要替换;等于就说明front前面的元素全都非空格。一开始front在behind前面2 * count个位置,不是空格时,front前移一个,behind也前移一个,两者距离不变;遇到空格时,front前移一个,behind变成了'%20'后前移三个,两个距离减少2,也就是每替换一个空格behind就向front靠近2个下标位置。因此直到空格替换完,front都在behind前面。而s中只有front前面的元素是没有复制到新s中的,front后面的元素都已经被复制到了s中的新位置,因此不存在没有遍历的元素被覆盖掉的情况。

另外,注意循环条件是front<behind,front=behind相等即说明空格替换完毕。

代码如下(C++):

cpp 复制代码
class Solution {
public:
    string replaceSpace(string s) {
        //统计空格数量
        int count = 0;
        for(int i = 0; i < s.size(); i++){
            if(s[i] == ' ')
                count++;
        }
        int original = s.size(); //保留原始长度
        s.resize(original + 2*count); //resize到新的长度,新增一截
        //注意循环条件是front<behind,front和behind相等即说明空格替换完毕
        for(int behind = s.size()-1, front = original -1; front<behind ; front--){
            if(s[front] == ' '){//替换空格
                s[behind--] = '0';
                s[behind--] = '2';
                s[behind--] = '%';
            }
            else
                s[behind--] = s[front];
        }
        return s;
    }
};

思考

这个题目不仅适用于string,对于其他可变长度的数据结构,比如vector也是可以的。先扩充,再利用双指针原地操作原元素,可以降低空间复杂度。

相关推荐
飞Link1 小时前
什么是 PX4?一文了解 PX4 在空地协同中的作用
算法·无人机
一去不复返的通信er8 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
考研保研资料分享9 小时前
985工科跨保上财应用统计:数学笔试、匿名面试与机试复盘
面试·职场和发展
程序 代码狂人10 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade11 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin77012 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君65813 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一14 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10014 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法